/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/osrf-common-nightly-1.1.0~hg20140814r12e5b2a24d90/osrf_msgs/msg/JointCommands.msg
 *
 */


#ifndef OSRF_MSGS_MESSAGE_JOINTCOMMANDS_H
#define OSRF_MSGS_MESSAGE_JOINTCOMMANDS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>

namespace osrf_msgs
{
template <class ContainerAllocator>
struct JointCommands_
{
  typedef JointCommands_<ContainerAllocator> Type;

  JointCommands_()
    : header()
    , name()
    , position()
    , velocity()
    , effort()
    , kp_position()
    , ki_position()
    , kd_position()
    , kp_velocity()
    , i_effort_min()
    , i_effort_max()  {
    }
  JointCommands_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , name(_alloc)
    , position(_alloc)
    , velocity(_alloc)
    , effort(_alloc)
    , kp_position(_alloc)
    , ki_position(_alloc)
    , kd_position(_alloc)
    , kp_velocity(_alloc)
    , i_effort_min(_alloc)
    , i_effort_max(_alloc)  {
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _name_type;
  _name_type name;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _position_type;
  _position_type position;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _velocity_type;
  _velocity_type velocity;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _effort_type;
  _effort_type effort;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _kp_position_type;
  _kp_position_type kp_position;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _ki_position_type;
  _ki_position_type ki_position;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _kd_position_type;
  _kd_position_type kd_position;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _kp_velocity_type;
  _kp_velocity_type kp_velocity;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _i_effort_min_type;
  _i_effort_min_type i_effort_min;

   typedef std::vector<double, typename ContainerAllocator::template rebind<double>::other >  _i_effort_max_type;
  _i_effort_max_type i_effort_max;




  typedef boost::shared_ptr< ::osrf_msgs::JointCommands_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::osrf_msgs::JointCommands_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct JointCommands_

typedef ::osrf_msgs::JointCommands_<std::allocator<void> > JointCommands;

typedef boost::shared_ptr< ::osrf_msgs::JointCommands > JointCommandsPtr;
typedef boost::shared_ptr< ::osrf_msgs::JointCommands const> JointCommandsConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::osrf_msgs::JointCommands_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::osrf_msgs::JointCommands_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace osrf_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'osrf_msgs': ['/tmp/buildd/osrf-common-nightly-1.1.0~hg20140814r12e5b2a24d90/osrf_msgs/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::osrf_msgs::JointCommands_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::osrf_msgs::JointCommands_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::osrf_msgs::JointCommands_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::osrf_msgs::JointCommands_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::osrf_msgs::JointCommands_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::osrf_msgs::JointCommands_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::osrf_msgs::JointCommands_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f298c98f3e9c7aae9376ac19f73bfba3";
  }

  static const char* value(const ::osrf_msgs::JointCommands_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf298c98f3e9c7aaeULL;
  static const uint64_t static_value2 = 0x9376ac19f73bfba3ULL;
};

template<class ContainerAllocator>
struct DataType< ::osrf_msgs::JointCommands_<ContainerAllocator> >
{
  static const char* value()
  {
    return "osrf_msgs/JointCommands";
  }

  static const char* value(const ::osrf_msgs::JointCommands_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::osrf_msgs::JointCommands_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Joint Command Message\n\
# This structure contains the gains to be applied to a joint.\n\
# The controller is a PID with feedforward desired torque:\n\
#\n\
#   kp_position     * ( position - measured_position )       +\n\
#   ki_position     * 1/s * ( position - measured_position ) +\n\
#   kd_position     * s * ( position - measured_position ) +\n\
#   kp_velocity    * ( velocity - measured_velocity )     +\n\
#   effort\n\
#\n\
Header header\n\
\n\
string[] name\n\
float64[] position\n\
float64[] velocity\n\
float64[] effort\n\
\n\
float64[] kp_position\n\
float64[] ki_position\n\
float64[] kd_position\n\
float64[] kp_velocity\n\
\n\
float64[] i_effort_min\n\
float64[] i_effort_max\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
";
  }

  static const char* value(const ::osrf_msgs::JointCommands_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::osrf_msgs::JointCommands_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.name);
      stream.next(m.position);
      stream.next(m.velocity);
      stream.next(m.effort);
      stream.next(m.kp_position);
      stream.next(m.ki_position);
      stream.next(m.kd_position);
      stream.next(m.kp_velocity);
      stream.next(m.i_effort_min);
      stream.next(m.i_effort_max);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct JointCommands_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::osrf_msgs::JointCommands_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::osrf_msgs::JointCommands_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "name[]" << std::endl;
    for (size_t i = 0; i < v.name.size(); ++i)
    {
      s << indent << "  name[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name[i]);
    }
    s << indent << "position[]" << std::endl;
    for (size_t i = 0; i < v.position.size(); ++i)
    {
      s << indent << "  position[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.position[i]);
    }
    s << indent << "velocity[]" << std::endl;
    for (size_t i = 0; i < v.velocity.size(); ++i)
    {
      s << indent << "  velocity[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.velocity[i]);
    }
    s << indent << "effort[]" << std::endl;
    for (size_t i = 0; i < v.effort.size(); ++i)
    {
      s << indent << "  effort[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.effort[i]);
    }
    s << indent << "kp_position[]" << std::endl;
    for (size_t i = 0; i < v.kp_position.size(); ++i)
    {
      s << indent << "  kp_position[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.kp_position[i]);
    }
    s << indent << "ki_position[]" << std::endl;
    for (size_t i = 0; i < v.ki_position.size(); ++i)
    {
      s << indent << "  ki_position[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.ki_position[i]);
    }
    s << indent << "kd_position[]" << std::endl;
    for (size_t i = 0; i < v.kd_position.size(); ++i)
    {
      s << indent << "  kd_position[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.kd_position[i]);
    }
    s << indent << "kp_velocity[]" << std::endl;
    for (size_t i = 0; i < v.kp_velocity.size(); ++i)
    {
      s << indent << "  kp_velocity[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.kp_velocity[i]);
    }
    s << indent << "i_effort_min[]" << std::endl;
    for (size_t i = 0; i < v.i_effort_min.size(); ++i)
    {
      s << indent << "  i_effort_min[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.i_effort_min[i]);
    }
    s << indent << "i_effort_max[]" << std::endl;
    for (size_t i = 0; i < v.i_effort_max.size(); ++i)
    {
      s << indent << "  i_effort_max[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.i_effort_max[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // OSRF_MSGS_MESSAGE_JOINTCOMMANDS_H
